=== modified file 'NEWS'
--- NEWS	2005-11-13 20:14:22 +0000
+++ NEWS	2005-11-17 21:55:55 +0000
@@ -70,7 +70,10 @@
     * All pending merges operations from Branch are now on WorkingTree.
       (Robert Collins)
 
-    * Branch.commit() has moved to WorkingTree.commit(). (Robert Collins)
+    * The follow operations from Branch have moved to WorkingTree:
+      add()
+      commit()
+      (Robert Collins)
 
 bzr 0.6 2005-10-28
 

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2005-11-13 20:14:22 +0000
+++ bzrlib/branch.py	2005-11-17 21:55:55 +0000
@@ -24,10 +24,9 @@
 
 
 import bzrlib
-from bzrlib.inventory import InventoryEntry
 import bzrlib.inventory as inventory
 from bzrlib.trace import mutter, note
-from bzrlib.osutils import (isdir, quotefn, compact_date, rand_bytes, 
+from bzrlib.osutils import (isdir, quotefn,
                             rename, splitpath, sha_file, appendpath, 
                             file_kind, abspath)
 import bzrlib.errors as errors
@@ -517,72 +516,6 @@
         inv = self.get_inventory(self.last_revision())
         return inv.root.file_id
 
-    @needs_write_lock
-    def add(self, files, ids=None):
-        """Make files versioned.
-
-        Note that the command line normally calls smart_add instead,
-        which can automatically recurse.
-
-        This puts the files in the Added state, so that they will be
-        recorded by the next commit.
-
-        files
-            List of paths to add, relative to the base of the tree.
-
-        ids
-            If set, use these instead of automatically generated ids.
-            Must be the same length as the list of files, but may
-            contain None for ids that are to be autogenerated.
-
-        TODO: Perhaps have an option to add the ids even if the files do
-              not (yet) exist.
-
-        TODO: Perhaps yield the ids and paths as they're added.
-        """
-        # TODO: Re-adding a file that is removed in the working copy
-        # should probably put it back with the previous ID.
-        if isinstance(files, basestring):
-            assert(ids is None or isinstance(ids, basestring))
-            files = [files]
-            if ids is not None:
-                ids = [ids]
-
-        if ids is None:
-            ids = [None] * len(files)
-        else:
-            assert(len(ids) == len(files))
-
-        inv = self.working_tree().read_working_inventory()
-        for f,file_id in zip(files, ids):
-            if is_control_file(f):
-                raise BzrError("cannot add control file %s" % quotefn(f))
-
-            fp = splitpath(f)
-
-            if len(fp) == 0:
-                raise BzrError("cannot add top-level %r" % f)
-
-            fullpath = os.path.normpath(self.abspath(f))
-
-            try:
-                kind = file_kind(fullpath)
-            except OSError:
-                # maybe something better?
-                raise BzrError('cannot add: not a regular file, symlink or directory: %s' % quotefn(f))
-
-            if not InventoryEntry.versionable_kind(kind):
-                raise BzrError('cannot add: not a versionable file ('
-                               'i.e. regular file, symlink or directory): %s' % quotefn(f))
-
-            if file_id is None:
-                file_id = gen_file_id(f)
-            inv.add_path(f, kind=kind, file_id=file_id)
-
-            mutter("add file %s file_id:{%s} kind=%r" % (f, file_id, kind))
-
-        self.working_tree()._write_inventory(inv)
-
     @needs_read_lock
     def print_file(self, file, revno):
         """Print `file` to stdout."""
@@ -603,7 +536,7 @@
         >>> b = ScratchBranch(files=['foo', 'foo~'])
         >>> map(str, b.unknowns())
         ['foo']
-        >>> b.add('foo')
+        >>> WorkingTree(b.base, b).add('foo')
         >>> list(b.unknowns())
         []
         >>> WorkingTree(b.base, b).remove('foo')
@@ -1163,40 +1096,3 @@
             break
         filename = head
     return False
-
-
-
-def gen_file_id(name):
-    """Return new file id.
-
-    This should probably generate proper UUIDs, but for the moment we
-    cope with just randomness because running uuidgen every time is
-    slow."""
-    import re
-    from binascii import hexlify
-    from time import time
-
-    # get last component
-    idx = name.rfind('/')
-    if idx != -1:
-        name = name[idx+1 : ]
-    idx = name.rfind('\\')
-    if idx != -1:
-        name = name[idx+1 : ]
-
-    # make it not a hidden file
-    name = name.lstrip('.')
-
-    # remove any wierd characters; we don't escape them but rather
-    # just pull them out
-    name = re.sub(r'[^\w.]', '', name)
-
-    s = hexlify(rand_bytes(8))
-    return '-'.join((name, compact_date(time()), s))
-
-
-def gen_root_id():
-    """Return a new tree-root file id."""
-    return gen_file_id('TREE_ROOT')
-
-

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2005-11-17 08:12:13 +0000
+++ bzrlib/builtins.py	2005-11-17 21:55:55 +0000
@@ -227,13 +227,10 @@
     takes_args = ['dir+']
 
     def run(self, dir_list):
-        b = None
-        
         for d in dir_list:
             os.mkdir(d)
             wt, dd = WorkingTree.open_containing(d)
-            b = wt.branch
-            b.add([dd])
+            wt.add([dd])
             print 'added', d
 
 
@@ -1059,7 +1056,7 @@
             mutter('.bzrignore is already versioned')
         else:
             mutter('need to make new .bzrignore file versioned')
-            tree.branch.add(['.bzrignore'])
+            tree.add(['.bzrignore'])
 
 
 class cmd_ignored(Command):

=== modified file 'bzrlib/check.py'
--- bzrlib/check.py	2005-11-10 03:03:53 +0000
+++ bzrlib/check.py	2005-11-17 21:55:55 +0000
@@ -34,7 +34,6 @@
 from bzrlib.trace import mutter
 from bzrlib.errors import BzrCheckError, NoSuchRevision
 from bzrlib.inventory import ROOT_ID
-from bzrlib.branch import gen_root_id
 
 
 class Check(object):

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2005-11-05 23:25:39 +0000
+++ bzrlib/commit.py	2005-11-17 21:55:55 +0000
@@ -77,7 +77,6 @@
                             kind_marker, is_inside_any, quotefn,
                             sha_string, sha_strings, sha_file, isdir, isfile,
                             split_lines)
-from bzrlib.branch import gen_file_id
 import bzrlib.config
 from bzrlib.errors import (BzrError, PointlessCommit,
                            HistoryMissing,

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2005-11-10 03:03:53 +0000
+++ bzrlib/inventory.py	2005-11-17 21:55:55 +0000
@@ -877,7 +877,7 @@
         The immediate parent must already be versioned.
 
         Returns the new entry object."""
-        from bzrlib.branch import gen_file_id
+        from bzrlib.workingtree import gen_file_id
         
         parts = bzrlib.osutils.splitpath(relpath)
         if len(parts) == 0:

=== modified file 'bzrlib/selftest/blackbox.py'
--- bzrlib/selftest/blackbox.py	2005-11-17 08:12:13 +0000
+++ bzrlib/selftest/blackbox.py	2005-11-17 21:55:55 +0000
@@ -318,7 +318,7 @@
     def test_diff_branches(self):
         self.build_tree(['branch1/', 'branch1/file', 'branch2/'])
         branch = Branch.initialize('branch1')
-        branch.add(['file'])
+        branch.working_tree().add(['file'])
         branch.working_tree().commit('add file')
         copy_branch(branch, 'branch2')
         print >> open('branch2/file', 'w'), 'new content'
@@ -1153,7 +1153,7 @@
     def test_log(self):
         self.build_tree(['branch/', 'branch/file'])
         branch = Branch.initialize('branch')
-        branch.add(['file'])
+        branch.working_tree().add(['file'])
         branch.working_tree().commit('add file', rev_id='A')
         url = self.get_remote_url('branch/file')
         output = self.capture('log %s' % url)

=== modified file 'bzrlib/selftest/test_commit.py'
--- bzrlib/selftest/test_commit.py	2005-11-07 20:17:57 +0000
+++ bzrlib/selftest/test_commit.py	2005-11-17 21:55:55 +0000
@@ -49,7 +49,7 @@
         """Commit and check two versions of a single file."""
         b = Branch.initialize('.')
         file('hello', 'w').write('hello world')
-        b.add('hello')
+        b.working_tree().add('hello')
         b.working_tree().commit(message='add hello')
         file_id = b.working_tree().path2id('hello')
 
@@ -73,7 +73,7 @@
         """Test a commit with a deleted file"""
         b = Branch.initialize('.')
         file('hello', 'w').write('hello world')
-        b.add(['hello'], ['hello-id'])
+        b.working_tree().add(['hello'], ['hello-id'])
         b.working_tree().commit(message='add hello')
 
         os.remove('hello')
@@ -86,7 +86,7 @@
         """Commit refuses unless there are changes or it's forced."""
         b = Branch.initialize('.')
         file('hello', 'w').write('hello')
-        b.add(['hello'])
+        b.working_tree().add(['hello'])
         b.working_tree().commit(message='add hello')
         self.assertEquals(b.revno(), 1)
         self.assertRaises(PointlessCommit,
@@ -112,7 +112,7 @@
         b = Branch.initialize('.')
         file('hello', 'w').write('hello')
         file('buongia', 'w').write('buongia')
-        b.add(['hello', 'buongia'],
+        b.working_tree().add(['hello', 'buongia'],
               ['hello-id', 'buongia-id'])
         b.working_tree().commit(message='add files',
                  rev_id='test@rev-1')
@@ -146,7 +146,7 @@
         """Test commit of a revision where a file is renamed."""
         b = Branch.initialize('.')
         self.build_tree(['hello'])
-        b.add(['hello'], ['hello-id'])
+        b.working_tree().add(['hello'], ['hello-id'])
         b.working_tree().commit(message='one', rev_id='test@rev-1', allow_pointless=False)
 
         b.rename_one('hello', 'fruity')
@@ -187,7 +187,7 @@
         b = Branch.initialize('.')
         r1 = 'test@rev-1'
         self.build_tree(['hello', 'a/', 'b/'])
-        b.add(['hello', 'a', 'b'], ['hello-id', 'a-id', 'b-id'])
+        b.working_tree().add(['hello', 'a', 'b'], ['hello-id', 'a-id', 'b-id'])
         b.working_tree().commit('initial', rev_id=r1, allow_pointless=False)
 
         b.move(['hello'], 'a')
@@ -222,7 +222,7 @@
         b = Branch.initialize('.')
         wt = b.working_tree()
         file('hello', 'w').write('hello world')
-        b.add(['hello'], ['hello-id'])
+        b.working_tree().add(['hello'], ['hello-id'])
         b.working_tree().commit(message='add hello')
 
         wt = b.working_tree()  # FIXME: kludge for aliasing of working inventory
@@ -240,7 +240,7 @@
         for i in range(4):
             file('hello', 'w').write((str(i) * 4) + '\n')
             if i == 0:
-                b.add(['hello'], ['hello-id'])
+                b.working_tree().add(['hello'], ['hello-id'])
             rev_id = 'test@rev-%d' % (i+1)
             rev_ids.append(rev_id)
             b.working_tree().commit(message='rev %d' % (i+1),
@@ -254,7 +254,7 @@
     def test_commit_new_subdir_child_selective(self):
         b = Branch.initialize('.')
         self.build_tree(['dir/', 'dir/file1', 'dir/file2'])
-        b.add(['dir', 'dir/file1', 'dir/file2'],
+        b.working_tree().add(['dir', 'dir/file1', 'dir/file2'],
               ['dirid', 'file1id', 'file2id'])
         b.working_tree().commit('dir/file1', specific_files=['dir/file1'], rev_id='1')
         inv = b.get_inventory('1')
@@ -268,7 +268,7 @@
         from bzrlib.errors import StrictCommitFailed
         b = Branch.initialize('.')
         file('hello', 'w').write('hello world')
-        b.add('hello')
+        b.working_tree().add('hello')
         file('goodbye', 'w').write('goodbye cruel world!')
         self.assertRaises(StrictCommitFailed, b.working_tree().commit,
             message='add hello but not goodbye', strict=True)
@@ -279,14 +279,14 @@
         from bzrlib.errors import StrictCommitFailed
         b = Branch.initialize('.')
         file('hello', 'w').write('hello world')
-        b.add('hello')
+        b.working_tree().add('hello')
         b.working_tree().commit(message='add hello', strict=True)
 
     def test_nonstrict_commit(self):
         """Try and commit with unknown files and strict = False, should work."""
         b = Branch.initialize('.')
         file('hello', 'w').write('hello world')
-        b.add('hello')
+        b.working_tree().add('hello')
         file('goodbye', 'w').write('goodbye cruel world!')
         b.working_tree().commit(message='add hello but not goodbye', strict=False)
 
@@ -295,7 +295,7 @@
         should work."""
         b = Branch.initialize('.')
         file('hello', 'w').write('hello world')
-        b.add('hello')
+        b.working_tree().add('hello')
         b.working_tree().commit(message='add hello', strict=False)
 
     def test_signed_commit(self):

=== modified file 'bzrlib/selftest/test_commit_merge.py'
--- bzrlib/selftest/test_commit_merge.py	2005-11-05 23:19:11 +0000
+++ bzrlib/selftest/test_commit_merge.py	2005-11-17 21:55:55 +0000
@@ -62,16 +62,14 @@
         self.assertEquals(rev.parent_ids,
                           ['y@u-0-1', 'x@u-0-1'])
 
-
-
     def test_merge_new_file(self):
         """Commit merge of two trees with no overlapping files."""
         self.build_tree(['x/', 'x/ecks', 'y/', 'y/why'])
 
         bx = Branch.initialize('x')
         by = Branch.initialize('y')
-        bx.add(['ecks'], ['ecks-id'])
-        by.add(['why'], ['why-id'])
+        bx.working_tree().add(['ecks'], ['ecks-id'])
+        by.working_tree().add(['why'], ['why-id'])
 
         commit(bx, 'commit one', rev_id='x@u-0-1', allow_pointless=True)
         commit(by, 'commit two', rev_id='y@u-0-1', allow_pointless=True)
@@ -79,7 +77,7 @@
         fetch(from_branch=bx, to_branch=by)
         # we haven't merged the texts, but let's fake it
         shutil.copyfile('x/ecks', 'y/ecks')
-        by.add(['ecks'], ['ecks-id'])
+        by.working_tree().add(['ecks'], ['ecks-id'])
         by.working_tree().add_pending_merge('x@u-0-1')
 
         # partial commit of merges is currently not allowed, because

=== modified file 'bzrlib/selftest/test_merge_core.py'
--- bzrlib/selftest/test_merge_core.py	2005-11-07 20:17:57 +0000
+++ bzrlib/selftest/test_merge_core.py	2005-11-17 21:55:55 +0000
@@ -568,7 +568,7 @@
         os.mkdir('a')
         a = Branch.initialize('a')
         file('a/file', 'wb').write('contents\n')
-        a.add('file')
+        a.working_tree().add('file')
         a.working_tree().commit('base revision', allow_pointless=False)
         b = copy_branch(a, 'b')
         file('a/file', 'wb').write('other contents\n')
@@ -598,12 +598,12 @@
         os.mkdir('a')
         a = Branch.initialize('a')
         file('a/a_file', 'wb').write('contents\n')
-        a.add('a_file')
+        a.working_tree().add('a_file')
         a.working_tree().commit('a_revision', allow_pointless=False)
         os.mkdir('b')
         b = Branch.initialize('b')
         file('b/b_file', 'wb').write('contents\n')
-        b.add('b_file')
+        b.working_tree().add('b_file')
         b.working_tree().commit('b_revision', allow_pointless=False)
         merge(['b', -1], ['b', 0], this_dir='a')
         self.assert_(os.path.lexists('a/b_file'))
@@ -615,12 +615,12 @@
         os.mkdir('a')
         a = Branch.initialize('a')
         file('a/file', 'wb').write('contents\n')
-        a.add('file')
+        a.working_tree().add('file')
         a.working_tree().commit('a_revision', allow_pointless=False)
         os.mkdir('b')
         b = Branch.initialize('b')
         file('b/file', 'wb').write('contents\n')
-        b.add('file')
+        b.working_tree().add('file')
         b.working_tree().commit('b_revision', allow_pointless=False)
         merge(['b', -1], ['b', 0], this_dir='a')
         self.assert_(os.path.lexists('a/file'))

=== modified file 'bzrlib/selftest/test_parent.py'
--- bzrlib/selftest/test_parent.py	2005-11-07 20:17:57 +0000
+++ bzrlib/selftest/test_parent.py	2005-11-17 21:55:55 +0000
@@ -45,7 +45,7 @@
         os.mkdir('from')
         branch_from = Branch.initialize('from')
         file('from/foo', 'wt').write('contents of foo')
-        branch_from.add('foo')
+        branch_from.working_tree().add('foo')
         branch_from.working_tree().commit('initial commit')
         
         os.mkdir('to')

=== modified file 'bzrlib/selftest/testannotate.py'
--- bzrlib/selftest/testannotate.py	2005-11-07 20:17:57 +0000
+++ bzrlib/selftest/testannotate.py	2005-11-17 21:55:55 +0000
@@ -43,7 +43,7 @@
         super(TestAnnotate, self).setUp()
         b = Branch.initialize('.')
         self.build_tree_contents([('hello.txt', 'my helicopter\n')])
-        b.add(['hello.txt'])
+        b.working_tree().add(['hello.txt'])
         b.working_tree().commit('add hello', 
                                 committer='test@user')
 

=== modified file 'bzrlib/selftest/testbranch.py'
--- bzrlib/selftest/testbranch.py	2005-11-07 20:17:57 +0000
+++ bzrlib/selftest/testbranch.py	2005-11-17 21:55:55 +0000
@@ -50,7 +50,7 @@
         b1 = Branch.initialize('b1')
         b2 = Branch.initialize('b2')
         file(os.sep.join(['b1', 'foo']), 'w').write('hello')
-        b1.add(['foo'], ['foo-id'])
+        b1.working_tree().add(['foo'], ['foo-id'])
         b1.working_tree().commit('lala!', rev_id='revision-1', allow_pointless=False)
 
         mutter('start fetch')
@@ -77,7 +77,7 @@
         os.mkdir('a')
         br_a = Branch.initialize("a")
         file('a/b', 'wb').write('b')
-        br_a.add('b')
+        br_a.working_tree().add('b')
         commit(br_a, "silly commit", rev_id='A')
         os.mkdir('b')
         br_b = Branch.initialize("b")
@@ -116,10 +116,10 @@
         """Copy only part of the history of a branch."""
         self.build_tree(['a/', 'a/one'])
         br_a = Branch.initialize('a')
-        br_a.add(['one'])
+        br_a.working_tree().add(['one'])
         br_a.working_tree().commit('commit one', rev_id='u@d-1')
         self.build_tree(['a/two'])
-        br_a.add(['two'])
+        br_a.working_tree().add(['two'])
         br_a.working_tree().commit('commit two', rev_id='u@d-2')
         br_b = copy_branch(br_a, 'b', revision='u@d-1')
         self.assertEqual(br_b.last_revision(), 'u@d-1')
@@ -209,8 +209,8 @@
 #         >>> from bzrlib.commit import commit
 #         >>> bzrlib.trace.silent = True
 #         >>> br1 = ScratchBranch(files=['foo', 'bar'])
-#         >>> br1.add('foo')
-#         >>> br1.add('bar')
+#         >>> br1.working_tree().add('foo')
+#         >>> br1.working_tree().add('bar')
 #         >>> commit(br1, "lala!", rev_id="REVISION-ID-1", verbose=False)
 #         >>> br2 = ScratchBranch()
 #         >>> br2.update_revisions(br1)

=== modified file 'bzrlib/selftest/testfetch.py'
--- bzrlib/selftest/testfetch.py	2005-11-07 20:17:57 +0000
+++ bzrlib/selftest/testfetch.py	2005-11-17 21:55:55 +0000
@@ -151,7 +151,7 @@
         os.mkdir('br1')
         br1 = Branch.initialize('br1')
         self.build_tree_contents([('br1/file', 'original contents\n')])
-        br1.add(['file'], ['this-file-id'])
+        br1.working_tree().add(['file'], ['this-file-id'])
         br1.working_tree().commit(message='rev 1-1', rev_id='1-1')
         copy_branch(br1, 'br2')
         br2 = Branch.open('br2')
@@ -200,7 +200,7 @@
     def test_weaves_are_retrieved_once(self):
         self.build_tree(("source/", "source/file", "target/"))
         branch = Branch.initialize("source")
-        branch.add(["file"], ["id"])
+        branch.working_tree().add(["file"], ["id"])
         branch.working_tree().commit("added file")
         print >>open("source/file", 'w'), "blah"
         branch.working_tree().commit("changed file")

=== modified file 'bzrlib/selftest/testinv.py'
--- bzrlib/selftest/testinv.py	2005-11-07 20:17:57 +0000
+++ bzrlib/selftest/testinv.py	2005-11-17 21:55:55 +0000
@@ -140,10 +140,10 @@
         self.branch = Branch.initialize('.')
         self.wt = self.branch.working_tree()
         print >> open('file', 'wb'), 'foo'
-        self.branch.add(['file'], ['fileid'])
+        self.branch.working_tree().add(['file'], ['fileid'])
         if has_symlinks():
             os.symlink('target1', 'symlink')
-            self.branch.add(['symlink'], ['linkid'])
+            self.branch.working_tree().add(['symlink'], ['linkid'])
         self.wt.commit('message_1', rev_id = '1')
         print >> open('file', 'wb'), 'bar'
         if has_symlinks():
@@ -242,7 +242,8 @@
         super(TestSnapshot, self).setUp()
         self.branch = Branch.initialize('.')
         self.build_tree(['subdir/', 'subdir/file'])
-        self.branch.add(['subdir', 'subdir/file'], ['dirid', 'fileid'])
+        self.branch.working_tree().add(['subdir', 'subdir/file'],
+                                       ['dirid', 'fileid'])
         if has_symlinks():
             pass
         self.wt = self.branch.working_tree()
@@ -330,7 +331,7 @@
         self.wt = self.branch.working_tree()
         self.wt.commit('new branch', allow_pointless=True, rev_id='A')
         self.inv_A = self.branch.get_inventory('A')
-        self.branch.add(['file'], ['fileid'])
+        self.branch.working_tree().add(['file'], ['fileid'])
         self.wt.commit('add file', rev_id='B')
         self.inv_B = self.branch.get_inventory('B')
         self.branch.put_controlfile('revision-history', 'A\n')

=== modified file 'bzrlib/selftest/testlog.py'
--- bzrlib/selftest/testlog.py	2005-11-07 20:17:57 +0000
+++ bzrlib/selftest/testlog.py	2005-11-17 21:55:55 +0000
@@ -125,7 +125,7 @@
 
 
         self.build_tree(['hello'])
-        b.add('hello')
+        b.working_tree().add('hello')
         b.working_tree().commit('add one file')
 
         lf = StringIO()

=== modified file 'bzrlib/selftest/testnonascii.py'
--- bzrlib/selftest/testnonascii.py	2005-10-24 12:48:52 +0000
+++ bzrlib/selftest/testnonascii.py	2005-11-17 21:55:55 +0000
@@ -35,4 +35,4 @@
             return
         br = Branch.initialize(u".")
         file("a", "w").write("hello")
-        br.add(["a"], ["a-id"])
+        br.working_tree().add(["a"], ["a-id"])

=== modified file 'bzrlib/selftest/testrevisionnamespaces.py'
--- bzrlib/selftest/testrevisionnamespaces.py	2005-11-07 20:17:57 +0000
+++ bzrlib/selftest/testrevisionnamespaces.py	2005-11-17 21:55:55 +0000
@@ -84,7 +84,7 @@
         """Ensure that the branch namespace pulls in the requisite content."""
         self.build_tree(['branch1/', 'branch1/file', 'branch2/'])
         branch = Branch.initialize('branch1')
-        branch.add(['file'])
+        branch.working_tree().add(['file'])
         branch.working_tree().commit('add file')
         copy_branch(branch, 'branch2')
         print >> open('branch2/file', 'w'), 'new content'

=== modified file 'bzrlib/selftest/teststatus.py'
--- bzrlib/selftest/teststatus.py	2005-11-07 20:17:57 +0000
+++ bzrlib/selftest/teststatus.py	2005-11-17 21:55:55 +0000
@@ -65,8 +65,8 @@
 
         tof = StringIO()
         self.build_tree(['hello.c', 'bye.c'])
-        b.add('hello.c')
-        b.add('bye.c')
+        b.working_tree().add('hello.c')
+        b.working_tree().add('bye.c')
         b.working_tree().commit('Test message')
 
         tof = StringIO()
@@ -82,7 +82,7 @@
                            '  hello.c\n'])
 
         self.build_tree(['more.c'])
-        b.add('more.c')
+        b.working_tree().add('more.c')
         b.working_tree().commit('Another test message')
         
         tof = StringIO()
@@ -132,8 +132,8 @@
         b = Branch.initialize('.')
 
         self.build_tree(['directory/','directory/hello.c', 'bye.c','test.c','dir2/'])
-        b.add('directory')
-        b.add('test.c')
+        b.working_tree().add('directory')
+        b.working_tree().add('test.c')
         b.working_tree().commit('testing')
         
         tof = StringIO()

=== modified file 'bzrlib/selftest/testtestament.py'
--- bzrlib/selftest/testtestament.py	2005-11-07 20:17:57 +0000
+++ bzrlib/selftest/testtestament.py	2005-11-17 21:55:55 +0000
@@ -43,8 +43,8 @@
         build_tree_contents([('hello', 'contents of hello file'),
                              ('src/', ),
                              ('src/foo.c', 'int main()\n{\n}\n')])
-        b.add(['hello', 'src', 'src/foo.c'],
-              ['hello-id', 'src-id', 'foo.c-id'])
+        b.working_tree().add(['hello', 'src', 'src/foo.c'],
+                             ['hello-id', 'src-id', 'foo.c-id'])
         b.working_tree().commit(message='add files and directories',
                  timestamp=1129025483,
                  timezone=36000,
@@ -95,7 +95,7 @@
         if not has_symlinks():
             return
         os.symlink('wibble/linktarget', 'link')
-        self.b.add(['link'], ['link-id'])
+        self.b.working_tree().add(['link'], ['link-id'])
         self.b.working_tree().commit(message='add symlink',
                  timestamp=1129025493,
                  timezone=36000,

=== modified file 'bzrlib/selftest/testworkingtree.py'
--- bzrlib/selftest/testworkingtree.py	2005-11-17 06:52:51 +0000
+++ bzrlib/selftest/testworkingtree.py	2005-11-17 21:55:55 +0000
@@ -112,8 +112,9 @@
     def get_pullable_branches(self):
         self.build_tree(['from/', 'from/file', 'to/'])
         br_a = Branch.initialize('from')
-        br_a.add('file')
-        br_a.working_tree().commit('foo', rev_id='A')
+        tree = br_a.working_tree()
+        tree.add('file')
+        tree.commit('foo', rev_id='A')
         br_b = Branch.initialize('to')
         return br_a, br_b
  
@@ -141,22 +142,20 @@
 
         self.assertRaises(NotVersionedError,
                           b.working_tree().revert, ['hello.txt'])
-        
-        b.add(['hello.txt'])
-        b.working_tree().commit('create initial hello.txt')
+        tree = WorkingTree(b.base, b)
+        tree.add(['hello.txt'])
+        tree.commit('create initial hello.txt')
 
         self.check_file_contents('hello.txt', 'initial hello')
         file('hello.txt', 'w').write('new hello')
         self.check_file_contents('hello.txt', 'new hello')
 
-        wt = b.working_tree()
-
         # revert file modified since last revision
-        wt.revert(['hello.txt'])
+        tree.revert(['hello.txt'])
         self.check_file_contents('hello.txt', 'initial hello')
         self.check_file_contents('hello.txt~', 'new hello')
 
         # reverting again does not clobber the backup
-        wt.revert(['hello.txt'])
+        tree.revert(['hello.txt'])
         self.check_file_contents('hello.txt', 'initial hello')
         self.check_file_contents('hello.txt~', 'new hello')

=== modified file 'bzrlib/selftest/versioning.py'
--- bzrlib/selftest/versioning.py	2005-11-13 18:57:26 +0000
+++ bzrlib/selftest/versioning.py	2005-11-17 21:55:55 +0000
@@ -116,14 +116,15 @@
         self.assertEquals(delta.added[0][0], 'dir')
         self.failIf(delta.modified)
 
-    def test_branch_add_in_unversioned(self):
+    def test_working_tree_add_in_unversioned(self):
         """Try to add a file in an unversioned directory.
 
-        "bzr add" adds the parent as necessary, but simple branch add
+        "bzr add" adds the parent as necessary, but simple working tree add
         doesn't do that.
         """
         from bzrlib.branch import Branch
         from bzrlib.errors import NotVersionedError
+        from bzrlib.workingtree import WorkingTree
 
         b = Branch.initialize('.')
 
@@ -131,7 +132,7 @@
                          'foo/hello'])
 
         self.assertRaises(NotVersionedError,
-                          b.add,
+                          WorkingTree(b.base, b).add,
                           'foo/hello')
         
         self.check_branch()

=== modified file 'bzrlib/selftest/whitebox.py'
--- bzrlib/selftest/whitebox.py	2005-11-07 20:17:57 +0000
+++ bzrlib/selftest/whitebox.py	2005-11-17 21:55:55 +0000
@@ -32,7 +32,7 @@
         b.working_tree().commit('commit pointless tree',
                  allow_pointless=True)
 
-        b.add('hello.txt')
+        b.working_tree().add('hello.txt')
         
         b.working_tree().commit('commit first added file',
                  allow_pointless=False)
@@ -52,7 +52,7 @@
         """Test renaming directories and the files within them."""
         b = Branch.initialize('.')
         self.build_tree(['dir/', 'dir/sub/', 'dir/sub/file'])
-        b.add(['dir', 'dir/sub', 'dir/sub/file'])
+        b.working_tree().add(['dir', 'dir/sub', 'dir/sub/file'])
 
         b.working_tree().commit('create initial state')
 

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2005-11-17 06:52:51 +0000
+++ bzrlib/workingtree.py	2005-11-17 21:55:55 +0000
@@ -46,22 +46,63 @@
 import stat
 import fnmatch
  
-from bzrlib.branch import Branch, needs_read_lock, needs_write_lock, quotefn
-import bzrlib.tree
+from bzrlib.branch import (Branch,
+                           is_control_file,
+                           needs_read_lock,
+                           needs_write_lock,
+                           quotefn)
+from bzrlib.errors import (BzrCheckError,
+                           DivergedBranches,
+                           NotBranchError,
+                           NotVersionedError)
+from bzrlib.inventory import InventoryEntry
 from bzrlib.osutils import (appendpath,
+                            compact_date,
                             file_kind,
                             isdir,
                             pumpfile,
                             splitpath,
+                            rand_bytes,
                             relpath)
-from bzrlib.errors import (BzrCheckError,
-                           DivergedBranches,
-                           NotBranchError,
-                           NotVersionedError)
+import bzrlib.tree
 from bzrlib.trace import mutter
 import bzrlib.xml5
 
 
+def gen_file_id(name):
+    """Return new file id.
+
+    This should probably generate proper UUIDs, but for the moment we
+    cope with just randomness because running uuidgen every time is
+    slow."""
+    import re
+    from binascii import hexlify
+    from time import time
+
+    # get last component
+    idx = name.rfind('/')
+    if idx != -1:
+        name = name[idx+1 : ]
+    idx = name.rfind('\\')
+    if idx != -1:
+        name = name[idx+1 : ]
+
+    # make it not a hidden file
+    name = name.lstrip('.')
+
+    # remove any wierd characters; we don't escape them but rather
+    # just pull them out
+    name = re.sub(r'[^\w.]', '', name)
+
+    s = hexlify(rand_bytes(8))
+    return '-'.join((name, compact_date(time()), s))
+
+
+def gen_root_id():
+    """Return a new tree-root file id."""
+    return gen_file_id('TREE_ROOT')
+
+
 class TreeEntry(object):
     """An entry that implements the minium interface used by commands.
 
@@ -276,6 +317,71 @@
             return bool(stat.S_ISREG(mode) and stat.S_IEXEC&mode)
 
     @needs_write_lock
+    def add(self, files, ids=None):
+        """Make files versioned.
+
+        Note that the command line normally calls smart_add instead,
+        which can automatically recurse.
+
+        This adds the files to the inventory, so that they will be
+        recorded by the next commit.
+
+        files
+            List of paths to add, relative to the base of the tree.
+
+        ids
+            If set, use these instead of automatically generated ids.
+            Must be the same length as the list of files, but may
+            contain None for ids that are to be autogenerated.
+
+        TODO: Perhaps have an option to add the ids even if the files do
+              not (yet) exist.
+
+        TODO: Perhaps callback with the ids and paths as they're added.
+        """
+        # TODO: Re-adding a file that is removed in the working copy
+        # should probably put it back with the previous ID.
+        if isinstance(files, basestring):
+            assert(ids is None or isinstance(ids, basestring))
+            files = [files]
+            if ids is not None:
+                ids = [ids]
+
+        if ids is None:
+            ids = [None] * len(files)
+        else:
+            assert(len(ids) == len(files))
+
+        inv = self.read_working_inventory()
+        for f,file_id in zip(files, ids):
+            if is_control_file(f):
+                raise BzrError("cannot add control file %s" % quotefn(f))
+
+            fp = splitpath(f)
+
+            if len(fp) == 0:
+                raise BzrError("cannot add top-level %r" % f)
+
+            fullpath = os.path.normpath(self.abspath(f))
+
+            try:
+                kind = file_kind(fullpath)
+            except OSError:
+                # maybe something better?
+                raise BzrError('cannot add: not a regular file, symlink or directory: %s' % quotefn(f))
+
+            if not InventoryEntry.versionable_kind(kind):
+                raise BzrError('cannot add: not a versionable file ('
+                               'i.e. regular file, symlink or directory): %s' % quotefn(f))
+
+            if file_id is None:
+                file_id = gen_file_id(f)
+            inv.add_path(f, kind=kind, file_id=file_id)
+
+            mutter("add file %s file_id:{%s} kind=%r" % (f, file_id, kind))
+        self._write_inventory(inv)
+
+    @needs_write_lock
     def add_pending_merge(self, *revision_ids):
         # TODO: Perhaps should check at this point that the
         # history of the revision is actually present?

